finley::ReferenceElement Struct Reference

this struct holds the realization of a reference element More...

`#include <ReferenceElements.h>`

## Public Member Functions

| ReferenceElement (ElementTypeId id, int order)
| constructor with type ID and integration order More...
| ~ReferenceElement ()
| destructor More...
int | getNumNodes () const

## Static Public Member Functions

static const ReferenceElementInfo * | getInfo (ElementTypeId id)
| returns the element information structure for the given type id More...
static ElementTypeId | getTypeId (const char *)
| returns the element type id from its textual representation More...

## Public Attributes

const ReferenceElementInfo * | Type
| type of the reference element More...
const ReferenceElementInfo * | LinearType
| type of the linear reference element More...
int | integrationOrder
| used integration order More...
int | numNodes
int | numLocalDim
int | numLinearNodes
const_ShapeFunction_ptr | Parametrization
const_ShapeFunction_ptr | BasisFunctions
const_ShapeFunction_ptr | LinearBasisFunctions
double * | DBasisFunctionDv
bool | DBasisFunctionDvShared

## Detailed Description

this struct holds the realization of a reference element

## Constructor & Destructor Documentation

## ReferenceElement()

finley::ReferenceElement::ReferenceElement | ( | ElementTypeId | id,
|  | int | order
| ) |  |

constructor with type ID and integration order

creates a ReferenceElement of type id and a given integration order

References finley::ReferenceElementInfo::BasisFunctions, BasisFunctions, DBasisFunctionDv, DBasisFunctionDvShared, finley::ShapeFunction::getInfo(), getInfo(), finley::QuadInfo::getMacro, finley::QuadInfo::getNumQuadNodes, finley::QuadInfo::getQuadNodes, integrationOrder, LinearBasisFunctions, LinearType, finley::ReferenceElementInfo::LinearTypeId, finley::QuadInfo::numDim, finley::ShapeFunctionInfo::numDim, numLinearNodes, numLocalDim, finley::ReferenceElementInfo::numNodes, numNodes, finley::ShapeFunctionInfo::numOrder, finley::ShapeFunctionInfo::numShapes, finley::ReferenceElementInfo::numSubElements, finley::ReferenceElementInfo::Parametrization, Parametrization, finley::QuadInfo_getInfo(), finley::ReferenceElementInfo::Quadrature, Type, and finley::ShapeFunctionInfo::TypeId.

## ~ReferenceElement()

finley::ReferenceElement::~ReferenceElement | ( |  | ) |

destructor

References DBasisFunctionDv, and DBasisFunctionDvShared.

## Member Function Documentation

## getInfo()

const ReferenceElementInfo * finley::ReferenceElement::getInfo | ( | ElementTypeId | id | ) |

static

returns the element information structure for the given type id

References finley::NoRef.

Referenced by ReferenceElement(), and finley::ReferenceElementSet::ReferenceElementSet().

## getNumNodes()

int finley::ReferenceElement::getNumNodes | ( |  | ) | const

inline

## getTypeId()

ElementTypeId finley::ReferenceElement::getTypeId | ( | const char * | element_type | ) |

static

returns the element type id from its textual representation

References finley::NoRef, and finley::ReferenceElementInfo::TypeId.

## Member Data Documentation

## BasisFunctions

const_ShapeFunction_ptr finley::ReferenceElement::BasisFunctions

Referenced by ReferenceElement().

## DBasisFunctionDv

double* finley::ReferenceElement::DBasisFunctionDv

pointer to derivatives to basis function corresponding to the Parametrization of quad points

Referenced by ReferenceElement(), and ~ReferenceElement().

## DBasisFunctionDvShared

bool finley::ReferenceElement::DBasisFunctionDvShared

if true indicates that DBasisFunctionDv is shared with another object which is managing it

Referenced by ReferenceElement(), and ~ReferenceElement().

## integrationOrder

int finley::ReferenceElement::integrationOrder

used integration order

Referenced by ReferenceElement().

## LinearBasisFunctions

const_ShapeFunction_ptr finley::ReferenceElement::LinearBasisFunctions

Referenced by ReferenceElement().

## LinearType

const ReferenceElementInfo* finley::ReferenceElement::LinearType

type of the linear reference element

Referenced by ReferenceElement().

## numLinearNodes

int finley::ReferenceElement::numLinearNodes

Referenced by ReferenceElement().

## numLocalDim

int finley::ReferenceElement::numLocalDim

Referenced by ReferenceElement().

## numNodes

int finley::ReferenceElement::numNodes

Referenced by ReferenceElement().

## Parametrization

const_ShapeFunction_ptr finley::ReferenceElement::Parametrization

Referenced by ReferenceElement().

## Type

const ReferenceElementInfo* finley::ReferenceElement::Type

type of the reference element

Referenced by ReferenceElement().

The documentation for this struct was generated from the following files:

- ReferenceElements.h
- ReferenceElements.cpp